<?php

namespace Litecms\Practicecheck\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class PracticecheckTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Practicecheck\Models\Practicecheck $practicecheck)
    {
        return [
            'id'                => $practicecheck->getRouteKey(),
            'key'               => [
                'public'    => $practicecheck->getPublicKey(),
                'route'     => $practicecheck->getRouteKey(),
            ], 
            'name'              => $practicecheck->name,
            'image'             => $practicecheck->image,
            'habbits'           => $practicecheck->habbits,
            'url'               => [
                'public'    => trans_url('practicecheck/'.$practicecheck->getPublicKey()),
                'user'      => guard_url('practicecheck/practicecheck/'.$practicecheck->getRouteKey()),
            ], 
            'status'            => trans('app.'.$practicecheck->status),
            'created_at'        => format_date($practicecheck->created_at),
            'updated_at'        => format_date($practicecheck->updated_at),
        ];
    }
}